#!/usr/bin/python

#ccGenerator.py
#Assignment Four: Python Moderately Complex Assignment - Coaster Counter data file generator
#Author: Nicholas Piccillo

#This program creates a JSON file containing 
#test data for the Coaster Counter program

#This program accepts two optional command line arguments:
#int - number of coasters to generate (multiple of 10)
#filename - specify a filename for the generated data file (ex. testdata.json)
#int is required if filename is specified

#Usage:
#python ccGenerator.py [int [filename]]

#To use this data file in Coaster Counter:
#python coastercounter.py filename
#
#When prompted to enter your name, use the name: testuser

import os
import sys
import json

def main():
    itr = 10
    filepath = "temp_cdata.json"
    if len(sys.argv) > 1:
        itr = int(sys.argv[1])
    if len(sys.argv) > 2:
        if os.path.isfile(sys.argv[2]):
            print ("%s already exists. Data will be overwritten." % sys.argv[2])
            response = input ("Would you like to continue? (y/n): ")
            if response == "y" or response == "Y":
                filepath = sys.argv[2]
            else:
                print ("Exiting ccGenerator")
                sys.exit()
    
    print ('Starting Generator:\n')
    dstring = '{"testuser":{"Park1":["C1","C2","C3","C4","C5","C6","C7","C8","C9","C10"]'
    i = 2
    for i in range(0, itr - 1):
        dstring += ',"Park'
        dstring += str(i + 2)
        dstring += '":["C1","C2","C3","C4","C5","C6","C7","C8","C9","C10"]'
    dstring += '}}'
    print (dstring)
    print ("\nGenerating JSON file ...\n")
    try:
        file = open(filepath, "w+")
        dstring = dstring.replace('\n','')
        file.write(dstring)
    except Exception as e:
        print ('Data file could not be created : %s\n' % e)
        sys.exit()
    print ("%s successfully created with %d generated coasters!" % (filepath, itr * 10))
    print ("To use this test data, run Coaster counter as: ")
    print ("python coastercounter.py %s" % filepath)
    print ("When prompted to enter your name, use the name: testuser")

#Call main function
if __name__ == '__main__':
    main()
